%Script for creating distance matrix for aquaculture facilities
%Read in coordinates fro locations from excel sheet
Lat = xlsread('Lokasjoner Salmar.xlsx','Ark1','D4:D22');
Lon = xlsread('Lokasjoner Salmar.xlsx','Ark1','E4:E22');

%Create zero matrix
dist = zeros(length(Lat));

%Calculate distances based on coordinates
for i = 1:length(Lat)
    for j = 1:length(Lon)
        dist(i,j) = distance(Lat(i),Lon(i),Lat(j),Lon(j),...
            earthRadius('nm'))*1.1;
    end
end
%Divide distance by vessel speed to get sailing time
TimeMatrix1 = dist./10; 
TimeMatrix2 = dist./9; 
TimeMatrix3 = dist./9; 
TimeMatrix4 = dist./8;
%Calculating fuel cost per hour based on fuel consumption of 100 l/h 
%and a price of 10 kr/l. 
CostMatrix1 = TimeMatrix1.*100.*10; 
CostMatrix2 = TimeMatrix2.*100.*10; 
CostMatrix3 = TimeMatrix3.*100.*10; 
CostMatrix4 = TimeMatrix4.*80.*10; 
