%%%%Script for creating feasible routes%%%%

clc
clear all
tic 
%Read in feasible timewindows
TimeWindow = xlsread('Lokasjoner Salmar.xlsx','Ark1','H26:I37'); 
%Read in feasible extended timewindows
%TimeWindow = xlsread('Lokasjoner Salmar.xlsx','Ark2','D4:E15'); 
%Read in duration of each job
JobDuration = xlsread('Lokasjoner Salmar.xlsx','Ark1','J26:M37'); 
%Read in the distance from the depot to each job
DistanceFromDepot = xlsread('Routegeneration.xlsx','Ark1','D4:D22');
%Read in binary matrix for jobtype-shiptype compatibility
JobShipCompatibility = xlsread('Routegeneration.xlsx','Ark2','D4:N7'); 
%Read in job type for each job
JobType = xlsread('Lokasjoner Salmar.xlsx','Ark1','G26:G37'); 
%Read in location for the jobs.
Location = xlsread('Lokasjoner Salmar.xlsx','Ark1','E26:E37'); 
%Read in Hsfactor to multiply with the HsData set to compensate for more
%inshore locations
Hsfactor = xlsread('Lokasjoner Salmar.xlsx','Ark1','I4:I22'); 
%Read in the cost of starving salmon before delousing
NumberSalmon = xlsread('Lokasjoner Salmar.xlsx','Ark1','P26:P37'); 
%Read in penalty for not performing a job.
Penalty = xlsread('Lokasjoner Salmar.xlsx','Ark1','Q26:Q37'); 
%Read in operational waveheight limit for each Job and shiptype
MaxHs = xlsread('Routegeneration.xlsx','Ark2','D20:N23'); 
%Read in lateral coordinates for port.
%Portx = xlsread('PortxPorty.xlsx','Ark1','E5:I23'); 
%Read in longitudinal coordinates for port.
%Porty = xlsread('PortxPorty.xlsx','Ark1','K5:O23'); 
%Set penalty value to very large number to make sure all jobs are 
%performed if possible.
Penalty = Penalty * 100;
GrowthRate = (0.49/100)/24; %Growth rate salmon per hour (11 degree celcius) 
rng('shuffle') %Shuffle the random number generator to make sure rand 
                %functions give different results

Distancegen; %Create distance matrix based on coordinates for locations. 
mcHs; %Create weather scenario
%Set starting number for where in weather matrix the weather should be 
%retrieved
HsStart = randi(length(simValues1)); 
Hs = zeros(1,2000); %Create zeros vector to put weather states in.
%Make sure that we do not try to retrieve weather states from outside of 
%vector length.
if HsStart >2000  
    HsStart = HsStart-2000; 
end
for i = 1:2000
    %Put the simulated weather states into the zeros vector created before.
    Hs(i) = simValues1(HsStart+i); 
end

%Create zeros matrix for to put sailing times in.
TravelTime = zeros(length(DistanceFromDepot),length(DistanceFromDepot),3); 
%Put calculated sailing times in matrix for each vessel type     
TravelTime(:,:,1) = TimeMatrix1;                                   
TravelTime(:,:,2) = TimeMatrix2;   
TravelTime(:,:,3) = TimeMatrix3;   
TravelTime(:,:,4) = TimeMatrix4;   

%Create zeros matrix for sailing times from port to each location.
TimeFromDepot = zeros(length(DistanceFromDepot),3); 
%Put calculated sailing time from port in vector for each vessel type 
TimeFromDepot(:,1) = DistanceFromDepot/10;   
TimeFromDepot(:,2) = DistanceFromDepot/9;  
TimeFromDepot(:,3) = DistanceFromDepot/9;  
TimeFromDepot(:,4) = DistanceFromDepot/8; 

%Create zeros matrix for cost for sailing from port. 
CostFromDepot = zeros(length(DistanceFromDepot),3); 
%Put calculated sailing costs from port in vector for each vessel type
CostFromDepot(:,1) = TimeFromDepot(:,1)*44.44*10;   
CostFromDepot(:,2) = TimeFromDepot(:,2)*44.44*10;                                                   
CostFromDepot(:,3) = TimeFromDepot(:,2)*44.44*10;  
CostFromDepot(:,4) = TimeFromDepot(:,3)*39.11*10;  
%Create zeros matrix forFor sailing costs between locations
TravelCost = zeros(length(DistanceFromDepot),length(DistanceFromDepot),3); 
%Put calculated sailing costs between locations into matrix for each vessel
%type
TravelCost(:,:,1) = CostMatrix1; 
TravelCost(:,:,2) = CostMatrix2;
TravelCost(:,:,3) = CostMatrix3; 
TravelCost(:,:,4) = CostMatrix4; 


A1 = []; %Create binary feasible routes matrix for ship type 1
A2 = []; %Create binary feasible routes matrix for ship type 2
A3 = []; %Create binary feasible routes matrix for ship type 3
A4 = []; %Create binary feasible routes matrix for ship type 4
%A4 = [];

 %Set initial number of feasible routes for each vessel type
numRoutes1 = 0;
numRoutes2 = 0;
numRoutes3 = 0;
numRoutes4 = 0;
%Set inital cost vector for routes travelled for each vessel type.
Cost1 = [];
Cost2 = [];
Cost3 = [];
Cost4 = [];

%Set initial time matrix fro routes travelled for each vessel type. 
Time1 = [];
Time2 = [];
Time3 = [];
Time4 = [];

%Cost of leasing vessel for the farmers
LeasingCostVessel= [6000 12000 17000 30000]; 
%Salary for crew per hour. Use this for waiting hours.(Overtime)
SalaryCrew = [930 1195 1195 1990]; 
%Fuel cost for doiung anchor handling operations 
FuelCostAH = 0.5.*[100*10 100*10 100*10 80*10];  
%Multiply wave limit with 100 if we assume perfect weather
MaxHs = 100*MaxHs; 
%Increase wave limit by 0.2 to test increased operability for vessels
%MaxHs = MaxHs + 0.2; 

for a = 1:4 %For each vesselk type
    A = zeros(length(JobType),200000); %Create binary matrix
    Time = zeros(length(JobType),200000); %Create time matrix
    numRoutes = 0; %Set initial number of feasible routes
    Cost = zeros(1,200000); %Create cost vector
    for i = 1:length(JobType) % For each job needed to be performed
    k = 0; %Set a counter to 0
    t = 0; %Set inital number of waited hours because of bad weather to 0.
    %Check if vessel can reach job before timewindow closes, if vessel is
    %compatible with job type, and if wave height is above set limit for
    %vessel type during operation
    if TimeFromDepot(Location(i),a) < TimeWindow(i,2) && ...
       JobShipCompatibility(a,JobType(i)) == 1 && max(Hs(max(ceil...
       (TimeFromDepot(Location(i),a)),TimeWindow(i,1)):ceil(max(...
       TimeFromDepot(Location(i),a),TimeWindow(i,1))+JobDuration(i,a))))...
       *Hsfactor(Location(i))>=MaxHs(a,JobType(i))
       numRoutes = numRoutes +1; %Increase number of routes travelled by 1
       t = 1; %Set number of hours waited due to bad weather to 1.
       A(i,numRoutes) =1; %Include new route in binary matrix
       %Include cost from depot in cost vector
       Cost(numRoutes) = CostFromDepot(Location(i),a); 
       %While wave height is above operational limit during operation,
       %increase hours waited by 1.
       while max(Hs(max(ceil(TimeFromDepot(Location(i),a)),...
             TimeWindow(i,1))+t:ceil(max(TimeFromDepot(Location(i),a),...
             TimeWindow(i,1))+JobDuration(i,a))+t))*Hsfactor(Location...
             (i))>=MaxHs(a,JobType(i))
            %Increase number of hours waited because of bad weather by 1 
            %hour.
            t = t+1; 
       end
       %Update time matrix
       Time(i,numRoutes) = max(TimeFromDepot(Location(i),a),TimeWindow...
                           (i,1))+t; 
       %Update cost vector                
       Cost(numRoutes) = Cost(numRoutes) + t*SalaryCrew(a); 
    end
       %Check if sailing time from depot plus eventual hours waited for bad
       %weather is within time window, if vessel is compatible with job 
       %type, and if wave height is below operational limit during job 
       %duration
    if TimeFromDepot(Location(i),a)+t < TimeWindow(i,2) && ...
       JobShipCompatibility(a,JobType(i)) == 1 && max(Hs(max(ceil(...
       TimeFromDepot(Location(i),a)),TimeWindow(i,1))+ceil(max(...
       TimeFromDepot(Location(i),a),TimeWindow(i,1))+JobDuration(i,a))+t...
       ))*Hsfactor(Location(i))<MaxHs(a,JobType(i))
       %Check if number of hours waited because of bad weather is greater 
       %than 0
       if t >0 
            %Check if current time is greater than start of time window
            if Time(i,numRoutes) >=TimeWindow(i,1) 
            %Update time matrix    
            Time(i,numRoutes) = Time(i,numRoutes) + JobDuration(i,a);
                %Check if job is in another production zone
                if Location(i) == 7 
                    %Add extra time for cleaning vessel if it crosses
                    %production zone
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; 
                end
            else %If time window for job has not opened yet.
            %Add cost for waiting for time window to open.  
            Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(i,1)-...
                Time(i,numRoutes))*SalaryCrew(a); 
            %Update time matrix
            Time(i,numRoutes) = TimeWindow(i,1) + JobDuration(i,a); 
                %Check if job is in another production zone
                if Location(i) == 7
                    %Add extra time for cleaning vessel if it crosses 
                    %production zone
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; 
                end
            end
       
       else %If number of hours waited because of bad weather is 0
            numRoutes = numRoutes + 1; %Update number of feasible routes
            A(i,numRoutes) = 1; %Add job to new row
            %Update cost vector
            Cost(numRoutes) = CostFromDepot(Location(i),a); 
            %Check if current time is greater than time window for job
            if TimeFromDepot(Location(i),a) >= TimeWindow(i,1) 
                %Update time matrix                                
                Time(i,numRoutes) = TimeFromDepot(Location(i),a) + ...
                    JobDuration(i,a); 
                %Check if job is in another production zone
                if Location(i) == 7 
                    %Add extra time for cleaning vessel if it crosses ...
                    %production zone
                    Time(i,numRoutes) = Time(i,numRoutes) + 24;
                end
            else %If time window for job has not opened yet.
                %Add cost for waiting for time window to open.
                Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(i,1)...
                    -TimeFromDepot(Location(i),a))*SalaryCrew(a); 
                 %Update time matrix
                Time(i,numRoutes) = TimeWindow(i,1) + JobDuration(i,a);
                %Check if job is in another production zone
                if Location(i) == 7 
                    %Add extra time for cleaning vessel if it crosses 
                    %production zone
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; 
                end
            end
        end
          
            
        n = 1; %Set counter
        %Create store matrix 1 to keep track of jobs already visited
        Store1 = []; 
        %Create store matrix 2 to add new jobs in storage.
        Store2 = []; 
        %Check new routes as long as more jobs can be added 
        while n<length(JobType)  
            %Check if we are in first step such that store matrix is empty
            if n == 1 
                %For remaining possible jobs to add to route
                for j = 1:length(JobType) 
                     %Set number of hours waited because of bad weather to 0
                    t = 0;
                    z=0; %Set counter to zero
                    x = 0; %Set binary variable to zero
                    if a == 3 %If vessel type is 25 catamaran with delouser
                        %If vessel does not cross production zone
                        if Location(i) ~=7 && Location(j) ~= 7 
                            %Check if jobtype finished is delousing and if
                            %next potential job is not delousing
                            if JobType(i) == 1 && JobType(j) ~= 1  
                            x = 1; %If yes, set binary variable to 1
                            %Check if jobtype finished is not delousing and
                            %if next potential job is delousing
                            elseif JobType(i) ~= 1 && JobType(j) == 1
                            x = 1; %If yes, set binary matrix to 1
                            end
                        %If vessel does not cross production zone
                        elseif Location(i) == 7 && Location(j) == 7 
                            %Check if jobtype finished is delousing and if
                            %next potential job is not delousing
                            if JobType(i) == 1 && JobType(j) ~= 1
                            x = 1; %If yes, set binary variable to 1
                            %Check if jobtype finished is not delousing and
                            %if next potential job is delousing
                            elseif JobType(i) ~= 1 && JobType(j) == 1
                            x = 1; %If yes, set binary variable to 1
                            end
                        end
                    end
                    %Check if vessel can reach new job before time window
                    %closes, if vessel is compatible with next job type and
                    %if wave height is above operational limit during job
                    %duration
                    if (Time(i,numRoutes) + (1-x)*TravelTime(Location(i)...
                       ,Location(j),a)+x*(TimeFromDepot(Location(i),a)...
                       +8+TimeFromDepot(Location(j),a)))< TimeWindow(j,...
                       2)&& A(j,numRoutes)==0 && JobShipCompatibility...
                       (a,JobType(j)) == 1 && max(Hs(max(ceil(Time(i,...
                       numRoutes)+(1-x)*TravelTime(Location(i),Location...
                       (j),a)+x*(TimeFromDepot(Location(i),a)+8+...
                       TimeFromDepot(Location(j),a))),TimeWindow(j,1)):...
                       ceil(max(Time(i,numRoutes)+(1-x)*TravelTime(...
                       Location(i),Location(j),a)+x*(TimeFromDepot(...
                       Location(i),a)+8+TimeFromDepot(Location(j),a)),...
                       TimeWindow(j,1))+JobDuration(j,a))))*Hsfactor(...
                       Location(j))>=MaxHs(a,JobType(j))
                    %Update number of feasible routes
                    numRoutes = numRoutes+1; 
                    k = k+1; %Update counter
                    Store1 = [Store1;j]; %Update store vector
                    %Update binary matrix
                    A(:,numRoutes) = A(:,numRoutes-k); 
                    %Update time matrix
                    Time(:,numRoutes) = Time(:,numRoutes-k); 
                    A(j,numRoutes) = 1; %Add new job to row
                    %Update cost vector with sailing cost to new job
                    Cost(numRoutes) = Cost(numRoutes-k)+(1-x)*TravelCost...
                        (Location(i),Location(j),a)+x*(CostFromDepot(...
                        Location(i),a)+10000+CostFromDepot(Location(j),a));
                    %Set number of hours waited because of bad weather to 1.
                    t = 1; 
                    z=1; %Set counter to 1
                    %While wave height is above operational limit during 
                    %operation, increase hours waited by 1.
                    while max(Hs(max(ceil(Time(i,numRoutes-1)+(1-x)*...
                          TravelTime(Location(i),Location(j),a)+x*(...
                          TimeFromDepot(Location(i),a)+8+TimeFromDepot...
                          (Location(j),a))),TimeWindow(j,1))+t:ceil(...
                          max(Time(i,numRoutes-1)+(1-x)*TravelTime(...
                          Location(i),Location(j),a)+x*(TimeFromDepot...
                          (Location(i),a)+8+TimeFromDepot(Location(j),a...
                          )),TimeWindow(j,1))+JobDuration(j,a))+t))*...
                          Hsfactor(Location(j))>=MaxHs(a,JobType(j))
                    %Increase number of hours waited because of bad weather
                    %by 1 hour. 
                    t = t+1;
                    end
                    %Update time meatrix
                    Time(j,numRoutes) = max(Time(i,numRoutes-k) + (1-x)...
                        *TravelTime(Location(i),Location(j),a)+x*(...
                        TimeFromDepot(Location(i),a)+8+TimeFromDepot...
                        (Location(j),a)),TimeWindow(j,1))+t; 
                    %Update cost vector
                    Cost(numRoutes) = Cost(numRoutes)+SalaryCrew(a)*t; 
                    end
                    %Check if vessel can reach new job before time window
                    %closes, if vessel is compatible with next job type and
                    %if wave height is below operational limit during job
                    %duration
                    if (Time(i,numRoutes-z) + (1-x)*TravelTime(Location...
                       (i),Location(j),a)+x*(TimeFromDepot(Location(i),...
                       a)+8+TimeFromDepot(Location(j),a))+t)< TimeWindow...
                       (j,2) && A(j,numRoutes-z)==0 && ...
                       JobShipCompatibility(a,JobType(j)) == 1 && max...
                       (Hs(max(ceil(Time(i,numRoutes-z)+(1-x)*TravelTime...
                       (Location(i),Location(j),a)+x*(TimeFromDepot...
                       (Location(i),a)+8+TimeFromDepot(Location(j),a))),...
                       TimeWindow(j,1))+t:ceil(max(Time(i,numRoutes-z)...
                       +(1-x)*TravelTime(Location(i),Location(j),a)+...
                       x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(...
                       Location(j),a)),TimeWindow(j,1))+JobDuration(j,a...
                       ))+t))*Hsfactor(Location(j))<MaxHs(a,JobType(j))
                        %Check if number of hours waited because of bad 
                        %weather is greater than 0
                        if t>0 
                            %Check if current time is greater than start of
                            %time window
                            if Time(j,numRoutes)  >=TimeWindow(j,1) 
                            %Update time in time matrix                                    
                            Time(j,numRoutes) = Time(j,numRoutes) +...
                                JobDuration(j,a); 
                                %Check if new job is in anoter production
                                %zone
                                if Location(i) ~= 7 && Location(j) == 7 
                                    %Add extra time for cleaning vessel if 
                                    %it crosses production zone
                                    Time(j,numRoutes) = Time(j,numRoutes...
                                        ) + 24; 
                                end
                                %Check if new job is in anoter production
                                %zone
                                if Location(i) == 7 && Location(j) ~= 7
                                    %Add extra time for cleaning vessel if
                                    %it crosses production zone
                                    Time(j,numRoutes) = Time(j,numRoutes...
                                        ) + 24; 
                                end
                            else %If time window for job has not opened
                            %Add cost for waiting for time window to open
                            Cost(numRoutes) = Cost(numRoutes) + (...
                                TimeWindow(j,1)-Time(j,numRoutes))...
                                *SalaryCrew(a);
                            %Update time matrix
                            Time(j,numRoutes) = TimeWindow(j,1) + ...
                                JobDuration(j,a); 
                                %Check if new job is in anoter production
                                %zone
                                if Location(i) ~= 7 && Location(j) == 7
                                    %Add extra time for cleaning vessel
                                    %if it crosses production zone
                                    Time(j,numRoutes) = Time(j,numRoutes...
                                        ) + 24; 
                                end
                                %Check if new job is in anoter production
                                %zone
                                if Location(i) == 7 && Location(j) ~= 7
                                    %Add extra time for cleaning vessel if
                                    %it crosses production zone
                                    Time(j,numRoutes) = Time(j,numRoutes...
                                        ) + 24; 
                                end
                            end
                        end
                        %Check if number of hours waited because of bad 
                        %weather is 0
                        if t == 0 
                        numRoutes = numRoutes +1; %Add new route
                        k = k+1; %Update counter
                        Store1 = [Store1;j]; %Add new job to store.
                        %Add new column to A
                        A(:,numRoutes) = A(:,numRoutes-k); 
                        %Add new column to Time
                        Time(:,numRoutes) = Time(:,numRoutes-k); 
                        %Add new column to cost vector
                        Cost(numRoutes) = Cost(numRoutes-k); 
                        A(j,numRoutes) = 1; %Add new job to to new column
                        %Update cost vector with sailing cost to new job
                        Cost(numRoutes) = Cost(numRoutes)+(1-x)*...
                            TravelCost(Location(i),Location(j),a)+x*...
                            (CostFromDepot(Location(i),a)+10000+...
                            CostFromDepot(Location(j),a));
                        %Check if time window has opened
                        if (Time(i,numRoutes-1) + (1-x)*TravelTime(...
                           Location(i),Location(j),a)+x*(TimeFromDepot...
                           (Location(i),a)+8+TimeFromDepot(Location(j),a...
                           )))>=TimeWindow(j,1)
                            %Update time in time matrix
                            Time(j,numRoutes) = Time(i,numRoutes-k) + ...
                                (1-x)*TravelTime(Location(i),Location(j)...
                                ,a)+x*(TimeFromDepot(Location(i),a)...
                                +8+TimeFromDepot(Location(j),a))+...
                            JobDuration(j,a); 
                            %Check if new job is in anoter production zone
                            if Location(i) ~= 7 && Location(j) == 7
                                %Add extra time for cleaning vessel if it 
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                            %Check if new job is in anoter production zone
                            if Location(i) == 7 && Location(j) ~= 7
                                %Add extra time for cleaning vessel if it 
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                        else %If time window for job has not opened
                        %Add cost for waiting for time window to open
                        Cost(numRoutes) = Cost(numRoutes) + (TimeWindow...
                            (j,1)-(Time(i,numRoutes-1)+(1-x)*...
                            TravelTime(Location(i),Location(j),a)+x*(...
                            TimeFromDepot(Location(i),a)+8+TimeFromDepot...
                            (Location(j),a))))*SalaryCrew(a); 
                        %Update time matrix
                        Time(j,numRoutes) = TimeWindow(j,1) +...
                            JobDuration(j,a);
                            %Check if new job is in anoter production zone
                            if Location(i) ~= 7 && Location(j) == 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                            %Check if new job is in anoter production zone
                            if Location(i) == 7 && Location(j) ~= 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                        end
                        end
                        %Check if current time is greater than time window
                        %for new job because of hours waited for bad 
                        %weather
                    elseif (Time(i,numRoutes-z) + (1-x)*TravelTime(...
                            Location(i),Location(j),a)+x*(TimeFromDepot...
                            (Location(i),a)+8+TimeFromDepot(Location(j)...
                            ,a))+t)>= TimeWindow(j,2)&& A(j,numRoutes-...
                            z)==0 && JobShipCompatibility(a,JobType(j))...
                            == 1 && t>0
                        %If yes
                        k = k-1; %Reduce counter
                        Store1(length(Store1)) = []; %Remove job added
                        A(:,numRoutes) = []; %Remove column from A matrix
                        %Remove column from time matrix
                        Time(:,numRoutes) = []; 
                        %Remove column from cost vector
                        Cost(:,numRoutes) = []; 
                        %Reduce number of feasible routes by 1. 
                        numRoutes=numRoutes-1;       
                    end
                end
            else %If we are not in first step
                %For all new jobs added jobs added we need to check next 
                %possible job to add.
                for c = 1:length(Store1) 
                    %For remaining possible jobs to add                    
                    for j = 1:length(JobType) 
                        %Set number of hours waited because of bad weather
                        %to 0
                        t = 0; 
                        z=0; %Set counter to zero
                        x=0; %Set binary variable to zero
                        %If vessel type is 25 m catamaran with delouser
                        if a == 3 
                            %If vessel does not cross production zone
                            if Location(Store1(c)) ~=7 && Location(j) ~= 7
                                %Check if jobtype finished is delousing 
                                %and if next potential job is not delousing
                                if JobType(Store1(c)) == 1 && JobType(j)...
                                        ~= 1
                                x = 1; %Set binary variable to 1
                                %Check if jobtype finished is not delousing
                                %and if next potential job is delousing
                                elseif JobType(Store1(c)) ~= 1 && ...
                                        JobType(j) == 1
                                x = 1; %Set binary variable to 1
                                end
                                %If vessel does not cross production zone
                            elseif Location(Store1(c)) == 7 && Location...
                                    (j) == 7
                                %Check if jobtype finished is delousing and 
                                %if next potential job is not delousing
                                if JobType(Store1(c)) == 1 && JobType(j)...
                                        ~= 1
                                x = 1; %Set binary variable to 1
                                %Check if jobtype finished is not delousing
                                %and if next potential job is delousing
                                elseif JobType(Store1(c)) ~= 1 && ...
                                        JobType(j) == 1
                                x = 1; %Set binary variable to 1
                                end
                            end
                        end
                        %Check if vessel can reach new job before time 
                        %window closes, if vessel is compatible with next 
                        %job type and if wave height is above operational 
                        %limit during job duration
                        if (Time(Store1(c),numRoutes-length(Store1)+c-...
                            length(Store2))+(1-x)*TravelTime(Location(...
                            Store1(c)),Location(j),a)+x*(TimeFromDepot(...
                            Location(Store1(c)),a)+8+TimeFromDepot(...
                            Location(j),a)))<TimeWindow(j,2)&& A(j,...
                            numRoutes-length(Store1)+c-length(Store2))...
                            == 0 && JobShipCompatibility(a,JobType(j))...
                            == 1 && max(Hs(max(ceil(Time(Store1(c),...
                            numRoutes-length(Store1)+c-length(Store2))...
                            +(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location...
                            (Store1(c)),a)+8+TimeFromDepot(Location(j),...
                            a))),TimeWindow(j,1)):ceil(max(Time(Store1...
                            (c),numRoutes-length(Store1)+c-length(Store2...
                            ))+(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location...
                            (Store1(c)),a)+8+TimeFromDepot(Location(j),a...
                            )),TimeWindow(j,1))+JobDuration(j,a))))...
                            *Hsfactor(Location(j))>=MaxHs(a,JobType(j))
                        numRoutes = numRoutes + 1; %Add new route
                        %Add new column to A
                        A(:,numRoutes) = A(:,numRoutes-length(Store1)-...
                            length(Store2)-1+c); 
                        %Add new column to Time
                        Time(:,numRoutes) = Time(:,numRoutes-length...
                            (Store1)-length(Store2)-1+c); 
                        %Add new column to Cost
                        Cost(numRoutes) = Cost(:,numRoutes-length(...
                            Store1)-length(Store2)-1+c); 
                        A(j,numRoutes) = 1; %Add new job to column
                        %Update cost vector with sailing cost to new job
                        Cost(numRoutes) = Cost(numRoutes)+(1-x)*...
                            TravelCost(Location(Store1(c)),Location(j),...
                            a)+x*(CostFromDepot(Location(Store1(c)),a)+...
                            10000+CostFromDepot(Location(j),a));
                        %Set number of hours waited because of bad weather
                        %to 1
                        t = 1; 
                        z=1; %Set counter to 1
                        %While wave height is above operational limit 
                        %during operation, increase hours waited by 1.
                        while max(Hs(max(ceil(Time(Store1(c),numRoutes-...
                              1-length(Store1)+c-length(Store2))+(1-x)*...
                            TravelTime(Location(Store1(c)),Location(j),...
                            a)+x*(TimeFromDepot(Location(Store1(c)),a)...
                            +8+TimeFromDepot(Location(j),a))),TimeWindow...
                            (j,1))+t:ceil(max(Time(Store1(c),numRoutes...
                            -1-length(Store1)+c-length(Store2))+(1-x)*...
                            TravelTime(Location(Store1(c)),Location(j),...
                            a)+x*(TimeFromDepot(Location(Store1(c)),a)+...
                            8+TimeFromDepot(Location(j),a)),TimeWindow...
                            (j,1))+JobDuration(j,a))+t))*Hsfactor(...
                            Location(j))>=MaxHs(a,JobType(j))
                        t = t+1; %increase hours waited by 1 hour.
                        end
                        %Update time matrix
                        Time(j,numRoutes) = max(Time(Store1(c),...
                            numRoutes-length(Store1)-length(Store2)-1+c)...
                            +(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location(...
                            Store1(c)),a)+8+TimeFromDepot(Location(j),...
                            a)),TimeWindow(j,1))+t;
                        %Update cost vector with cost for waiting for bad
                        %weather
                        Cost(numRoutes) = Cost(numRoutes) + ...
                            SalaryCrew(a)*t;
                        end
                        %Check if vessel can reach new job before time 
                        %window closes, if vessel is compatible with next
                        %job type and if wave height is below operational 
                        %limit during job duration
                        if (Time(Store1(c),numRoutes-z-length(Store1)+c-...
                            length(Store2))+(1-x)*TravelTime(Location(...
                            Store1(c)),Location(j),a)+x*(TimeFromDepot(...
                            Location(Store1(c)),a)+8+TimeFromDepot(...
                            Location(j),a))+t)<TimeWindow(j,2)&& A(j,...
                            numRoutes-z-length(Store1)+c-length(Store2))...
                            == 0 && JobShipCompatibility(a,JobType(j))...
                            == 1 && max(Hs(max(ceil(Time(Store1(c),...
                            numRoutes-z-length(Store1)+c-length(Store2))...
                            +(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location...
                            (Store1(c)),a)+8+TimeFromDepot(Location(j),a...
                            ))),TimeWindow(j,1))+t:ceil(max(Time(Store1...
                            (c),numRoutes-z-length(Store1)+c-length(...
                            Store2))+(1-x)*TravelTime(Location(Store1(c...
                            )),Location(j),a)+x*(TimeFromDepot(Location...
                            (Store1(c)),a)+8+TimeFromDepot(Location(j),...
                            a)),TimeWindow(j,1))+JobDuration(j,a))+t))...
                            *Hsfactor(Location(j))<MaxHs(a,JobType(j))
                        %Check if number of hours waited because of bad 
                        %weather is greater than 0
                        if t>0 
                            %Check if current time is greater than time
                            %window for new job
                          if Time(j,numRoutes)  >=TimeWindow(j,1)
                              %Update time in time matrix
                            Time(j,numRoutes) = Time(j,numRoutes) +...
                                JobDuration(j,a); 
                            %If next job is in another production zone
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                            %If next job is in another production zone
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                %Add extra time for cleaning vessel if it 
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                          else %If time window for new job has not opened
                               %yet
                            %Add cost for waiting for time window to open
                            Cost(numRoutes) = Cost(numRoutes) + ...
                                (TimeWindow(j,1)-Time(j,numRoutes))...
                                 *SalaryCrew(a);
                            %Update time matrix
                            Time(j,numRoutes) = TimeWindow(j,1) + ...
                                JobDuration(j,a);
                            %If next job is in another production zone
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                            %If next job is in another production zone
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                %Add extra time for cleaning vessel if it 
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                          end
                        end 
                        %If number of hours waited for bad weather is zero
                        if t == 0 
                         numRoutes = numRoutes + 1; %Add new route
                         %Add new column to A
                         A(:,numRoutes) = A(:,numRoutes-length(Store1)-...
                             length(Store2)-1+c); 
                         %Add new column to Time
                         Time(:,numRoutes) = Time(:,numRoutes-length...
                             (Store1)-length(Store2)-1+c);
                         %Add new column to Cost
                         Cost(numRoutes) = Cost(:,numRoutes-length(...
                             Store1)-length(Store2)-1+c); 
                         A(j,numRoutes) = 1; %Add new job to column
                         %Update cost vector with sailing cost to new job
                         Cost(numRoutes) = Cost(numRoutes)+(1-x)*...
                             TravelCost(Location(Store1(c)),Location(j)...
                             ,a)+x*(CostFromDepot(Location(Store1(c)),a)...
                             +10000+CostFromDepot(Location(j),a));
                         %Check if current time is greater than time window
                         %for new job
                         if (Time(Store1(c),numRoutes-1-length(Store1)...
                            +c-length(Store2))+(1-x)*TravelTime(Location...
                            (Store1(c)),Location(j),a)+x*(TimeFromDepot...
                            (Location(Store1(c)),a)+8+TimeFromDepot...
                            (Location(j),a)))>=TimeWindow(j,1)
                        %Update time matrix
                         Time(j,numRoutes) = Time(Store1(c),numRoutes-...
                             length(Store1)-length(Store2)-1+c)+(1-x)*...
                             TravelTime(Location(Store1(c)),Location(j)...
                             ,a)+x*(TimeFromDepot(Location(Store1(c)),a)...
                             +8+TimeFromDepot(Location(j),a))+...
                             JobDuration(j,a); 
                            %If next job is in another production zone
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                            %If next job is in another production zone
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                %Add extra time for cleaning vessel if it 
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                         else %If timw window has not opened yet
                             %add cost for waiting for time window to open 
                             Cost(numRoutes) = Cost(numRoutes) + ...
                                 (TimeWindow(j,1)-(Time(Store1(c),...
                                 numRoutes-1-length(Store1)+c-length(...
                                 Store2))+(1-x)*TravelTime(Location(...
                                 Store1(c)),Location(j),a)+x*(...
                                 TimeFromDepot(Location(Store1(c)),a)+...
                                 8+TimeFromDepot(Location(j),a))))*...
                                 SalaryCrew(a);
                             %Update time matrix
                             Time(j,numRoutes) = TimeWindow(j,1) +...
                                 JobDuration(j,a);
                            %If next job is in another production zone 
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                             %If next job is in another production zone 
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                %Add extra time for cleaning vessel if it
                                %crosses production zone
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; 
                            end
                         end
                         
                        end
                        Store2 = [Store2;j]; %Add new job to store.
                        %Check if current time is greater than time window
                        %for new job because of hours waited for bad 
                        %weather
                        elseif (Time(Store1(c),numRoutes-z-length(Store1...
                                )+c-length(Store2))+(1-x)*TravelTime(...
                                Location(Store1(c)),Location(j),a)+...
                                x*(TimeFromDepot(Location(Store1(c)),a)...
                                +8+TimeFromDepot(Location(j),a))+t)>=...
                                TimeWindow(j,2)&& A(j,numRoutes-z-...
                                length(Store1)+c-length(Store2)) == 0 &&...
                                JobShipCompatibility(a,JobType(j)) == 1....
                                && t>0
                        A(:,numRoutes) = []; %Remove column from A matrix
                        Time(:,numRoutes) = []; %Remove column from time
                        Cost(:,numRoutes) = []; %Remove column from cost
                        %Reduce number of feasible routes by 1
                        numRoutes=numRoutes-1; 
                        end
                    end
                end
                %Move new jobs in store to first store matrix 
                Store1 = Store2; 
                Store2 = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    
    %Check if current time is greater than time window for new
    %job because of hours waited for bad weather   
    elseif TimeFromDepot(Location(i),a)+t >= TimeWindow(i,2) &&...
            JobShipCompatibility(a,JobType(i)) == 1 ...
            && sum(A(:,numRoutes)) == 1
        A(:,numRoutes)=[]; %Remove column from A matrix
        Time(:,numRoutes)=[]; %Remove column from time
        Cost(:,numRoutes) = []; %Remove column from cost
        numRoutes= numRoutes-1; %Reduce number of feasible routes by 1
    end
    end
    
    A( :, ~any(A,1) ) = [];  %removing zero-columns
    Time( :, ~any(Time,1) ) = [];  %removing zero-columns
    Cost(Cost==0) = []; %removing zero-columns
    
    %Add time and cost for sailing back to port
    for x=1:size(A,2) %For number of columns in A matrix
        for y = 1:size(A,1) %For number of rows in A matrix
        if Time(y,x) == max(Time(:,x))
            %Add cost for sailing from last job to port
            Cost(x) = Cost(x) + CostFromDepot(Location(y),a);
            %Add time for sailing from last job to port
            Time(y,x) = Time(y,x) + TimeFromDepot(Location(y),a);
        break
        end
        end
        
    end
    
    %Add additional costs. Cost for leasing vessel, for starving salmon
    %before delousing operations and fuel used during anchor handling
    %operations
    for x=1:size(A,2) %For number of columns in A matrix
        for y = 1:size(A,1) %For number of rows in A matrix
            if A(y,x) == 1
                %Add cost for leasing vessel
                Cost(x) = Cost(x) + LeasingCostVessel(a)*JobDuration(y,a);               
            elseif A(y,x) == JobType(y)
                %Check if start time of jobs performed is greater than time
                %window for that job
                if Time(y,x)-JobDuration(y,a)-TimeWindow(y,1)>0
                %Add cost for starving salmon this extra amount of time
                Cost(x) = Cost(x) + (4.5-4.5/(1+GrowthRate)^(Time(y,x)-...
                    0.5*JobDuration(y,a)-TimeWindow(y,1)))*NumberSalmon...
                    (y)*63;           
                end
            elseif A(y,x) == 1 && (JobType(y) == 2 || JobType(y) == 9)
                %Add cost  for fuel used during anchor handling operations
                Cost(x) = Cost(x) + JobDuration(y,a)*FuelCostAH(a);
            end
        end
    end

%Store A matrix, time matrix, number of feasible routes and cost vector for
%each vessel in own matrices.
    if a == 1
        A1 = A;
        Time1 = Time;
        numRoutes1 = numRoutes;
        Cost1 = Cost;
    elseif a== 2
        A2 = A;
        Time2 = Time;
        numRoutes2 = numRoutes;
        Cost2 = Cost;
    elseif a == 3
        A3 = A;
        Time3 = Time;
        numRoutes3 = numRoutes;
        Cost3 = Cost;
    elseif a == 4
        A4 = A;
        Time4 = Time;
        numRoutes4 = numRoutes;
        Cost4 = Cost;
    end
end
%Sum total number of feasible routes created for each vessel type
numRoutesTot = numRoutes1 + numRoutes2 + numRoutes3+numRoutes4;
%Create datafiles to be used for optimization model in Xpress
numJobs = length(JobType); %Number of jobs to performed 
A = [A1,A2,A3,A4]; %All A matrices
Cost = [Cost1, Cost2, Cost3,Cost4]; %All cost vectors
Time = [Time1, Time2, Time3, Time4]; %All time matrices
fopen('Datafile.txt','wt'); %Open datafile to write data to
fileID = fopen('Datafile.txt','w'); %Create file ID
%Write total number of routes to datafile
fprintf(fileID,'numRoutesTotal :  %2d \n',numRoutesTot);
%Write number of feasible routes for each vessel to datafile
fprintf(fileID,'numRoutes1 :  %2d \n',numRoutes1);
fprintf(fileID,'numRoutes2 :  %2d \n',numRoutes2);
fprintf(fileID,'numRoutes3 :  %2d \n',numRoutes3);
fprintf(fileID,'numRoutes4 :  %2d \n',numRoutes4);
%Write number of jobs to be performed to datafile
fprintf(fileID,'numJobs :  %2d \n',numJobs);
%Write number of vessel types to datafile
fprintf(fileID,'numVesselType : %2d \n',length(LeasingCostVessel));
%Write A matrix to datafile
fprintf(fileID,'A : [ \n');
for i = 1:size(A,1)
    for j = 1:size(A,2)
        fprintf(fileID,'%2d',A(i,j));
    end
        fprintf(fileID,'\n');
end
fprintf(fileID,' ]\n');
%Write cost vector to datafile
fprintf(fileID,'Cost : [');
for i = 1:length(Cost);
    fprintf(fileID,'%12.2f',Cost(i));      
end
fprintf(fileID,' ]\n');
%Write penalty for not doing a job to datafile
fprintf(fileID,'Penalty : [\n');
for i =1:length(JobType)
    fprintf(fileID,'%2d\n',Penalty(i));
end
fprintf(fileID,' ]\n');
%Write investment cost for each vessel type to datafile
fprintf(fileID,'CostNewVessels : [40202 86434 117274 213126] \n'); 

fclose(fileID); %Close datafile

moselexec RouteOpt.mos %Run optimization model in Xpress

OptimalRoutes = load('Result.dat'); %Load optimal routes found in Xpress

clearvars min max %Clear variables 
%Create zero matrix for optimal routes
OptRot = zeros(length(JobType),length(OptimalRoutes));
%Create zero matrix for time during each route
AscTime = zeros(length(JobType),length(OptimalRoutes));
for i = 1:length(OptimalRoutes)
    AscTime(:,i) = sort(Time(:,OptimalRoutes(i)));
end
%Put time after each job is finished in matrix
for i = 1:length(OptimalRoutes)
    t = 1;
    for j = 1:length(JobType)
        if AscTime(j,i) >0
            for m = 1:length(JobType)
                if AscTime(j,i) == Time(m,OptimalRoutes(i))
                   OptRot(t,i) = m;
                   t = t+1;
                end
            end
        end
    end
end
%Display optimal routes in command window
 disp('Optimal routes:')
 disp(transpose(OptRot))
%Results = 'Results';
%Create zero matrix for time after each job is finished
TimeafterJob = zeros(5,length(OptRot(:,1)));
%Create zero matrix for duration of each route
MaxTime = zeros(5,length(OptRot(:,1)));
%Create zero matrix for optimal routes travelled
RoutesTravelled = zeros(5,length(OptRot(:,1)));
for i = 1:length(OptimalRoutes) %For number of optimal routes found
    disp('Total duration of route:')%Display total duration of routes
    disp(max(Time(:,OptimalRoutes(i))))
    %Create matrix for duration of each route
    MaxTime(i) = max(Time(:,OptimalRoutes(i)));
    %Display time afetr each job is finished
    disp('Time after each job completed:') 
    disp(transpose(sort(Time(:,OptimalRoutes(i)))))
    %Create matrix for time after each job is finished 
    TimeafterJob(i,:) = transpose(sort(Time(:,OptimalRoutes(i))));
    %Create matrix for routes travelled
    RoutesTravelled(i,:) = transpose(OptRot(:,i));
end

%Create text vectors to be written to a excel file for easier 
%interpretation of results  
A = {'OptimalRoutes';'OptimalRoutes';'OptimalRoutes';'OptimalRoutes';...
    'OptimalRoutes'};
B = {'Duration';'Duration';'Duration';'Duration';'Duration'};
C = {'Time after Job';'Time after Job';'Time after Job';'Time after Job'...
    ;'Time after Job'};
D = {'Total Cost'};
E = {'Vessels used';'Vessels used';'Vessels used';'Vessels used';...
    'Vessels used'};
F = {'Jobs not performed';'Jobs not performed';'Jobs not performed'};
%Write results to excel file 
xlswrite('Resultater hysesong optimering.xlsx',A,'Ark1','A1')
xlswrite('Resultater hysesong optimering.xlsx',B,'Ark1','A6')
xlswrite('Resultater hysesong optimering.xlsx',C,'Ark1','A11')
xlswrite('Resultater hysesong optimering.xlsx',D,'Ark1','A16')
xlswrite('Resultater hysesong optimering.xlsx',E,'Ark1','A17')
xlswrite('Resultater hysesong optimering.xlsx',F,'Ark1','A22')
xlswrite('Resultater hysesong optimering.xlsx',RoutesTravelled,'Ark1'...
    ,'B1')
xlswrite('Resultater hysesong optimering.xlsx',MaxTime,'Ark1','B6')
xlswrite('Resultater hysesong optimering.xlsx',TimeafterJob,'Ark1','B11')
%Load cost for each route from Xpress
CostRoutes = load('CostRoutes.dat');
xlswrite('Resultater hysesong optimering.xlsx',CostRoutes,'Ark1','N1')
%Load total cost for whole week from Xpress
TotalCost = load('Cost.dat');
%Load vessels used for each route from Xpress
Vessels = load('Vessels.dat');
%Load jobs not performed from Xpress
NotPerformed = load('NotPerformed.dat');
xlswrite('Resultater hysesong optimering.xlsx',Vessels,'Ark1','B17')
%Read in penalty for not performing a job.
Penalty1 = xlsread('Lokasjoner Salmar.xlsx','Ark1','Q26:Q37'); 
if isempty(NotPerformed) == false %If there are jobs that are not performed
    xlswrite('Resultater hysesong optimering.xlsx',NotPerformed,'Ark1',...
        'B22')
    for i = 1:length(NotPerformed)
    %Adjust value of total cost for each route. Replace penalty used in
    %Xpress for not doing a job with actual penalty. Penalties used in
    %Xpress are very big in order to make sure all jobs that are possible
    %to perform are performed regardless of the cost
    TotalCost = TotalCost-Penalty(NotPerformed(i))+Penalty1(...
        NotPerformed(i)); 
    end
end
xlswrite('Resultater hysesong optimering.xlsx',TotalCost,'Ark1','B16')
%Create plot of the significant wave heights the routes are exposed to. 
figure(1)

subplot(2,2,1)
set(gca,'FontSize',14) 
hold on
plot(Hs(1:ceil(max(max(Time(:,OptimalRoutes))))))
title('Simulated significant waveheight week 1')
xlabel('Time [hours]')
ylabel('Significant waveheight [m]')
%Create zeros matrix for job types performed for the optimal routes
OptJobType = zeros(size(OptRot));
%Create zero matrix for locations for the optimal routes
OptLocation = zeros(size(OptRot));
%Create matrices for job types and locations visited on the optimal routes
%travelled
for i = 1:size(OptRot,1)
    for j = 1:size(OptRot,2)
        if OptRot(i,j) >0 
        OptJobType(i,j) = JobType(OptRot(i,j));
        OptLocation(i,j) = Location(OptRot(i,j));
        end
    end
end
%Display job types and locations visited on each route travelled
disp('Jobtypes:')
disp(transpose(OptJobType))
disp('Locations:')
disp(transpose(OptLocation))



%Create plots showing the routes travelled on a google map.

figure(2)

set(gca,'FontSize',16)

hold on
route=zeros(1,size(OptLocation,2));
for i = 1:size(OptLocation,2)
    x = [];
    y = [];
    labels=[];
    for j = 1:size(OptLocation,1)
        if OptLocation(j,i)>0
        x(j) = Lat(OptLocation(j,i));
        y(j) = Lon(OptLocation(j,i));
        end
    end
    a = find(OptLocation(:,i));
    %Create vector containing lateral coordinates for locations
    %visited on optimal routes
    x = [Portx(OptLocation(1,i),:),x,fliplr(Portx(OptLocation(a(end),i)...
        ,:))];
    %Create vector containing longitudinal coordinates for locations
    %visited on optimal routes
    y = [Porty(OptLocation(1,i),:),y,fliplr(Porty(OptLocation(a(end),i)...
        ,:))];
    labels = cellstr(num2str([1:(length(x)-10)]'));
    plot(y(6:length(y)-5),x(6:length(x)-5),'o')
    %If vessel type is 1
    if OptimalRoutes(i) <=numRoutes1 
        route(i)=plot(y,x,'--b','DisplayName','Route 15 m cat');
        text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,...
            'VerticalAlignment','bottom','HorizontalAlignment',...
            'right','color','blue')
    %If vessel type is 2
    elseif OptimalRoutes(i) >numRoutes1 && OptimalRoutes(i) <=(...
            numRoutes1+numRoutes2) 
        route(i) = plot(y,x,'--k','DisplayName','Route 25 m cat');
        text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,...
            'VerticalAlignment','bottom','HorizontalAlignment',...
            'left','color','black')
    %If vessel type is 3
    elseif OptimalRoutes(i)>(numRoutes1+numRoutes2) && OptimalRoutes(i)...
            <=(numRoutes1+numRoutes2+numRoutes3)
        route(i) = plot(y,x,'--r','DisplayName',...
            'Route 25 m cat with delouser');
        text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,...
            'VerticalAlignment','top','HorizontalAlignment',...
            'right','color','red')
    %If vessel type is 4
    else
        route(i)= plot(y,x,'--m','DisplayName','Route 40 m mono');
        text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,...
            'VerticalAlignment','top','HorizontalAlignment',...
            'left','color','magenta')
    end
end
plot_google_map %Use plotting script found online to plot routes
%Set legend, title, x- and y-label
legend([route],'Location','northwest')
title('Routes travelled week 1')
xlabel('Longitude','FontSize', 16)
ylabel('Latitude','FontSize',16)
toc %Record time used by algorithm


 FeasibleRoutesWeek2; %Run route generation algorithmn for week 2
 FeasibleRoutesWeek3; %Run route generation algorithmn for week 3
 FeasibleRoutesWeek4; %Run route generation algorithmn for week 4
            
            
             