%Script for creating feasible routes 
%This script is not as well commeted as the script for week 1, but
%everything is exactly the same, except for the input data.


clear all
tic 
TimeWindow = xlsread('Lokasjoner Salmar.xlsx','Ark1','H60:I70'); %Read in feasible timewindows
%TimeWindow = xlsread('Lokasjoner Salmar.xlsx','Ark2','D38:E48'); %Read in extended feasible timewindows
JobDuration = xlsread('Lokasjoner Salmar.xlsx','Ark1','J60:M70'); %Read in duration of each job
DistanceFromDepot = xlsread('Routegeneration.xlsx','Ark1','D4:D22'); %Read in the distance from the depot to each job
JobShipCompatibility = xlsread('Routegeneration.xlsx','Ark2','D4:N7'); %Read in binary matrix for jobtype-shiptype compatibility
JobType = xlsread('Lokasjoner Salmar.xlsx','Ark1','G60:G70'); %Read in job type for each job
Location = xlsread('Lokasjoner Salmar.xlsx','Ark1','E60:E70'); %Read in location for the jobs.
Hsfactor = xlsread('Lokasjoner Salmar.xlsx','Ark1','I4:I22'); %Read in Hsfactor to multiply with the HsData set to compensate for more inshore locations
NumberSalmon = xlsread('Lokasjoner Salmar.xlsx','Ark1','P60:P70'); %Read in the cost of starving salmon before delousing
Penalty = xlsread('Lokasjoner Salmar.xlsx','Ark1','Q60:Q70'); %Read in penalty for not performing a job.
MaxHs = xlsread('Routegeneration.xlsx','Ark2','D20:N23'); %Read in operational waveheight limit for each Job and shiptype
Portx = xlsread('PortxPorty.xlsx','Ark1','E5:I23'); %Read in lateral coordinates for port.
Porty = xlsread('PortxPorty.xlsx','Ark1','K5:O23'); %Read in longitudinal coordinates for port.

GrowthRate = (0.49/100)/24; %Growth rate salmon per hour (11 degree celcius) 
rng('shuffle')
Sannsynlighet_skattekost;
Distancegen;
mcHs;
HsStart = randi(length(simValues1));
Hs = zeros(1,2000);
if HsStart >2000
    HsStart = HsStart-2000;
end
for i = 1:2000
    Hs(i) = simValues1(HsStart+i);
end

TravelTime = zeros(length(DistanceFromDepot),length(DistanceFromDepot),3);
TravelTime(:,:,1) = TimeMatrix1;
TravelTime(:,:,2) = TimeMatrix2;
TravelTime(:,:,3) = TimeMatrix3;
TravelTime(:,:,4) = TimeMatrix4;

TimeFromDepot = zeros(length(DistanceFromDepot),3);
TimeFromDepot(:,1) = DistanceFromDepot/10+504;
TimeFromDepot(:,2) = DistanceFromDepot/9+504;
TimeFromDepot(:,3) = DistanceFromDepot/9+504;
TimeFromDepot(:,4) = DistanceFromDepot/8+504;
%TimeFromDepot(:,4) = DistanceFromDepot/20;

CostFromDepot = zeros(length(DistanceFromDepot),3);
CostFromDepot(:,1) = (TimeFromDepot(:,1)-504)*44.44*10;
CostFromDepot(:,2) = (TimeFromDepot(:,2)-504)*44.44*10;
CostFromDepot(:,3) = (TimeFromDepot(:,2)-504)*44.44*10;
CostFromDepot(:,4) = (TimeFromDepot(:,3)-504)*39.11*10;

TravelCost = zeros(length(DistanceFromDepot),length(DistanceFromDepot),3);
TravelCost(:,:,1) = CostMatrix1;
TravelCost(:,:,2) = CostMatrix2;
TravelCost(:,:,3) = CostMatrix3;
TravelCost(:,:,4) = CostMatrix4;


A1 = []; %Create binary feasible routes matrix for ship type 1
A2 = []; %Create binary feasible routes matrix for ship type 2
A3 = []; %Create binary feasible routes matrix for ship type 3
A4 = []; %Create binary feasible routes matrix for ship type 4
%A4 = [];

 %Set initial number of feasible routes
numRoutes1 = 0;
numRoutes2 = 0;
numRoutes3 = 0;
numRoutes4 = 0;

Cost1 = [];
Cost2 = [];
Cost3 = [];
Cost4 = [];
% 
% Revenue1 = [];
% Revenue2 = [];
% Revenue3 = [];

Time1 = [];
Time2 = [];
Time3 = [];
Time4 = [];


LeasingCostVessel= [6000 12000 17000 30000]; %Cost of leasing vessel for the farmers
SalaryCrew = [930 1195 1195 1990]; %Salary for crew per hour. Use this for waiting hours.(Overtime)
FuelCostAH = 0.5.*[100*10 100*10 100*10 80*10];    

MaxHs = 100*MaxHs;
%MaxHs = MaxHs + 0.2;

for a = 1:4
    A = zeros(length(JobType),200000); %Create binary matrix
    Time = zeros(length(JobType),200000); %Create time matrix
    numRoutes = 0;
    Cost = zeros(1,200000); %Create cost vector
    %Revenue = [];
    for i = 1:length(JobType)
    k = 0;
    t = 0;
    if TimeFromDepot(Location(i),a) < TimeWindow(i,2) && JobShipCompatibility(a,JobType(i)) == 1 ...
       && max(Hs(max(ceil(TimeFromDepot(Location(i),a)),TimeWindow(i,1)):...
       ceil(max(TimeFromDepot(Location(i),a),TimeWindow(i,1))+JobDuration(i,a))))*Hsfactor(Location(i))>=MaxHs(a,JobType(i))
       numRoutes = numRoutes +1;
%        A = [A,zeros(size(JobDuration,1),1)]; %Create new row for new route
%        Time = [Time,zeros(size(JobDuration,1),1)]; %Create new row for new route
%        Cost = [Cost,0]; %Create new row for new route
       t = 1;
       A(i,numRoutes) =1;
       Cost(numRoutes) = CostFromDepot(Location(i),a);
       while max(Hs(max(ceil(TimeFromDepot(Location(i),a)),TimeWindow(i,1))+t:...
               ceil(max(TimeFromDepot(Location(i),a),TimeWindow(i,1))+JobDuration(i,a))+t))...
               *Hsfactor(Location(i))>=MaxHs(a,JobType(i))
            t = t+1;
       end
           Time(i,numRoutes) = max(TimeFromDepot(Location(i),a),TimeWindow(i,1))+t;
           Cost(numRoutes) = Cost(numRoutes) + SalaryCrew(a)*t;
    end
        
    if TimeFromDepot(Location(i),a)+t < TimeWindow(i,2) && JobShipCompatibility(a,JobType(i)) == 1 ...
       &&  max(Hs(max(ceil(TimeFromDepot(Location(i),a)),TimeWindow(i,1))+t:...
       ceil(max(TimeFromDepot(Location(i),a),TimeWindow(i,1))+JobDuration(i,a))+t))*...
       Hsfactor(Location(i))<MaxHs(a,JobType(i))%Check feasible start jobs.
       if t >0
            if Time(i,numRoutes) >=TimeWindow(i,1)
            Time(i,numRoutes) = Time(i,numRoutes) + JobDuration(i,a);
                if Location(i) == 7
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                end
            else
            Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(i,1)-Time(i,numRoutes))*SalaryCrew(a);    
            Time(i,numRoutes) = TimeWindow(i,1) + JobDuration(i,a);
                if Location(i) == 7
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                end
            end
       
       else 
            numRoutes = numRoutes + 1; %Create a route for each feasible start job.
%             A = [A,zeros(size(JobDuration,1),1)];%Create new row for new route
%             Time = [Time,zeros(size(JobDuration,1),1)]; %Create new row for new route
%             Cost = [Cost,0];
            A(i,numRoutes) = 1; %Add job to new row
            Cost(numRoutes) = CostFromDepot(Location(i),a);
            if TimeFromDepot(Location(i),a) >= TimeWindow(i,1) 
                Time(i,numRoutes) = TimeFromDepot(Location(i),a) + JobDuration(i,a); %Add new time to new row
                if Location(i) == 7
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                end
            else
                Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(i,1)-TimeFromDepot(Location(i),a))*SalaryCrew(a);
                Time(i,numRoutes) = TimeWindow(i,1) + JobDuration(i,a); 
                if Location(i) == 7
                    Time(i,numRoutes) = Time(i,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                end
            end
        end
          
            
        n = 1; %Set counter
        
        Store1 = []; %Create store matrix 1 to keep track of jobs already visited
        Store2 = []; %Create store matrix 2 to add new jobs in storage.
        while n<length(JobType) %Check new routes as long as more jobs can be added            
            if n == 1  %Check if we are in first step such that store matrix is empty
                for j = 1:length(JobType)
                    t = 0;
                    z=0;
                    x = 0;
                    if a == 3
                        if Location(i) ~=7 && Location(j) ~= 7
                            if JobType(i) == 1 && JobType(j) ~= 1
                            x = 1;
                            elseif JobType(i) ~= 1 && JobType(j) == 1
                            x = 1;
                            end
                        elseif Location(i) == 7 && Location(j) == 7
                            if JobType(i) == 1 && JobType(j) ~= 1
                            x = 1;
                            elseif JobType(i) ~= 1 && JobType(j) == 1
                            x = 1;
                            end
                        end
                    end
                    if (Time(i,numRoutes) + (1-x)*TravelTime(Location(i),Location(j),a)+ ...
                            x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))) < TimeWindow(j,2)... %Check timewindows for feasible jobs and make sure to not add jobs already added
                        && A(j,numRoutes)==0 && JobShipCompatibility(a,JobType(j)) == 1 ...
                        && max(Hs(max(ceil(Time(i,numRoutes)+(1-x)*TravelTime(Location(i),Location(j),a)+...
                        x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))),TimeWindow(j,1)):...
                        ceil(max(Time(i,numRoutes)+(1-x)*TravelTime(Location(i),Location(j),a)+...
                        x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a)),TimeWindow(j,1))...
                        +JobDuration(j,a))))*Hsfactor(Location(j))>=MaxHs(a,JobType(j))
                    numRoutes = numRoutes+1;
                    k = k+1;
                    Store1 = [Store1;j];
%                     A = [A,A(:,numRoutes-k)] ; %Add new row to A
%                     Time = [Time,Time(:,numRoutes-k)]; %Add new row to Time
%                     Cost = [Cost,Cost(:,numRoutes-k)];
                    A(:,numRoutes) = A(:,numRoutes-k);
                    Time(:,numRoutes) = Time(:,numRoutes-k);
                    A(j,numRoutes) = 1; %Add new job to row
                    Cost(numRoutes) = Cost(numRoutes-k)+(1-x)*TravelCost(Location(i),Location(j),a)+...
                        x*(CostFromDepot(Location(i),a)+10000+CostFromDepot(Location(j),a));
                    t = 1;
                    z=1;
                    while max(Hs(max(ceil(Time(i,numRoutes-1)+(1-x)*TravelTime(Location(i),Location(j),a)+...
                            x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))),TimeWindow(j,1))+t:...
                        ceil(max(Time(i,numRoutes-1)+(1-x)*TravelTime(Location(i),Location(j),a)+...
                        x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a)),TimeWindow(j,1))...
                        +JobDuration(j,a))+t))*Hsfactor(Location(j))>=MaxHs(a,JobType(j))
                    t = t+1;
                    end
                    Time(j,numRoutes) = max(Time(i,numRoutes-k) + (1-x)*TravelTime(Location(i),Location(j),a)+...
                        x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a)),TimeWindow(j,1))+t;
                    Cost(numRoutes) = Cost(numRoutes) + SalaryCrew(a)*t;
                    end
                    if (Time(i,numRoutes-z) + (1-x)*TravelTime(Location(i),Location(j),a)+...
                            x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))+t) < TimeWindow(j,2)... %Check timewindows for feasible jobs and make sure to not add jobs already added
                        && A(j,numRoutes-z)==0 && JobShipCompatibility(a,JobType(j)) == 1 ...
                        && max(Hs(max(ceil(Time(i,numRoutes-z)+(1-x)*TravelTime(Location(i),Location(j),a)+...
                        x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))),TimeWindow(j,1))+t:...
                        ceil(max(Time(i,numRoutes-z)+(1-x)*TravelTime(Location(i),Location(j),a)+...
                        x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a)),TimeWindow(j,1))...
                        +JobDuration(j,a))+t))*Hsfactor(Location(j))<MaxHs(a,JobType(j))
                        if t>0
                            if Time(j,numRoutes)  >=TimeWindow(j,1)
                            Time(j,numRoutes) = Time(j,numRoutes) +JobDuration(j,a); %Update time in time matrix
                                if Location(i) ~= 7 && Location(j) == 7
                                    Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                                end
                                if Location(i) == 7 && Location(j) ~= 7
                                    Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                                end
                            else 
                            Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(j,1)-Time(j,numRoutes))*SalaryCrew(a);
                            Time(j,numRoutes) = TimeWindow(j,1) + JobDuration(j,a);
                                if Location(i) ~= 7 && Location(j) == 7
                                    Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                                end
                                if Location(i) == 7 && Location(j) ~= 7
                                    Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                                end
                            end
                        end
                        if t == 0
                        numRoutes = numRoutes +1; %Add new route
                        k = k+1; %Update counter
                        Store1 = [Store1;j]; %Add new job to store.
                        A(:,numRoutes) = A(:,numRoutes-k);  %Add new row to A
                        Time(:,numRoutes) = Time(:,numRoutes-k); %Add new row to Time
                        Cost(numRoutes) = Cost(numRoutes-k);
                        A(j,numRoutes) = 1; %Add new job to row
                        Cost(numRoutes) = Cost(numRoutes)+(1-x)*TravelCost(Location(i),Location(j),a)+...
                            x*(CostFromDepot(Location(i),a)+10000+CostFromDepot(Location(j),a));
                        if (Time(i,numRoutes-1) + (1-x)*TravelTime(Location(i),Location(j),a)+...
                                x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))) >=TimeWindow(j,1)
                        Time(j,numRoutes) = Time(i,numRoutes-k) + (1-x)*TravelTime(Location(i),Location(j),a)+...
                            x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))+JobDuration(j,a); %Update time in time matrix
                            if Location(i) ~= 7 && Location(j) == 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                            if Location(i) == 7 && Location(j) ~= 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                        else
                        Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(j,1)-(Time(i,numRoutes-1)+...
                        (1-x)*TravelTime(Location(i),Location(j),a)+x*(TimeFromDepot(Location(i),a)+8+...
                        TimeFromDepot(Location(j),a))))*SalaryCrew(a);
                        Time(j,numRoutes) = TimeWindow(j,1) + JobDuration(j,a);
                            if Location(i) ~= 7 && Location(j) == 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                            if Location(i) == 7 && Location(j) ~= 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                        end
                        end
                    elseif (Time(i,numRoutes-z) + (1-x)*TravelTime(Location(i),Location(j),a)+...
                            x*(TimeFromDepot(Location(i),a)+8+TimeFromDepot(Location(j),a))+t) >= TimeWindow(j,2)... %Check timewindows for feasible jobs and make sure to not add jobs already added
                        && A(j,numRoutes-z)==0 && JobShipCompatibility(a,JobType(j)) == 1 ...
                        && t>0
                        k = k-1;
                        Store1(length(Store1)) = [];
                        A(:,numRoutes) = [];
                        Time(:,numRoutes) = [];
                        Cost(:,numRoutes) = [];
                        numRoutes=numRoutes-1;
                        
                    end
                end
            else 
                for c = 1:length(Store1) %For all new jobs added we need to check next possible job to add.
                    for j = 1:length(JobType)
                        t = 0;
                        z=0;
                        x=0;
                        if a == 3
                            if Location(Store1(c)) ~=7 && Location(j) ~= 7
                                if JobType(Store1(c)) == 1 && JobType(j) ~= 1
                                x = 1;
                                elseif JobType(Store1(c)) ~= 1 && JobType(j) == 1
                                x = 1;
                                end
                            elseif Location(Store1(c)) == 7 && Location(j) == 7
                                if JobType(Store1(c)) == 1 && JobType(j) ~= 1
                                x = 1;
                                elseif JobType(Store1(c)) ~= 1 && JobType(j) == 1
                                x = 1;
                                end
                            end
                        end
                        if (Time(Store1(c),numRoutes-length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)+8+TimeFromDepot(Location(j),a)))...
                            <TimeWindow(j,2)&& A(j,numRoutes-length(Store1)+c-length(Store2)) == 0 ...
                            && JobShipCompatibility(a,JobType(j)) == 1 && max(Hs(max(ceil(Time(Store1(c),numRoutes...
                            -length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location(Store1(c)),Location(j),a)+...
                            x*(TimeFromDepot(Location(Store1(c)),a)+8+TimeFromDepot(Location(j),a))),...
                            TimeWindow(j,1)):ceil(max(Time(Store1(c),numRoutes-length(Store1)+c-length(Store2))...
                            +(1-x)*TravelTime(Location(Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)...
                            +8+TimeFromDepot(Location(j),a)),TimeWindow(j,1))+JobDuration(j,a))))...
                            *Hsfactor(Location(j))>=MaxHs(a,JobType(j))
                        numRoutes = numRoutes + 1; %Add new route
                        A(:,numRoutes) = A(:,numRoutes-length(Store1)-length(Store2)-1+c); %Add new row to A
                        Time(:,numRoutes) = Time(:,numRoutes-length(Store1)-length(Store2)-1+c); %Add new row to Time
                        Cost(numRoutes) = Cost(:,numRoutes-length(Store1)-length(Store2)-1+c); %Add new row to Cost
                        A(j,numRoutes) = 1; %Add new job to row
                        Cost(numRoutes) = Cost(numRoutes)+(1-x)*TravelCost(Location(Store1(c)),Location(j),a)...
                            +x*(CostFromDepot(Location(Store1(c)),a)+10000+CostFromDepot(Location(j),a));
                        t = 1;
                        z=1;
                        while max(Hs(max(ceil(Time(Store1(c),numRoutes-1-length(Store1)+c-length(Store2))...
                            +(1-x)*TravelTime(Location(Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)...
                            +8+TimeFromDepot(Location(j),a))),TimeWindow(j,1))+t:ceil(max(Time(Store1(c),...
                            numRoutes-1-length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)+8+TimeFromDepot(Location(j),a)),...
                            TimeWindow(j,1))+JobDuration(j,a))+t))*Hsfactor(Location(j))>=MaxHs(a,JobType(j))
                        t = t+1;
                        end
                        Time(j,numRoutes) = max(Time(Store1(c),numRoutes-length(Store1)-length(Store2)-1+c)...
                                +(1-x)*TravelTime(Location(Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),...
                                a)+8+TimeFromDepot(Location(j),a)),TimeWindow(j,1))+t;
                        Cost(numRoutes) = Cost(numRoutes) + SalaryCrew(a)*t;    
                        end
                        if (Time(Store1(c),numRoutes-z-length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location...
                                (Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)+8+...
                                TimeFromDepot(Location(j),a))+t)<TimeWindow(j,2)... 
                            && A(j,numRoutes-z-length(Store1)+c-length(Store2)) == 0 && JobShipCompatibility(a,JobType(j)) == 1 ...
                            && max(Hs(max(ceil(Time(Store1(c),numRoutes-z-length(Store1)+c-length(Store2))...
                            +(1-x)*TravelTime(Location(Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)...
                            +8+TimeFromDepot(Location(j),a))),TimeWindow(j,1))+t:ceil(max(Time(Store1(c),...
                            numRoutes-z-length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location(Store1(c)),...
                            Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)+8+TimeFromDepot(Location(j),a))...
                            ,TimeWindow(j,1))+JobDuration(j,a))+t))*Hsfactor(Location(j))<MaxHs(a,JobType(j))
                        if t>0
                          if Time(j,numRoutes)  >=TimeWindow(j,1)
                            Time(j,numRoutes) = Time(j,numRoutes) +JobDuration(j,a); %Update time in time matrix
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                          else 
                            Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(j,1)-Time(j,numRoutes))*SalaryCrew(a);
                            Time(j,numRoutes) = TimeWindow(j,1) + JobDuration(j,a);
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                          end
                        end 
                        if t == 0
                         numRoutes = numRoutes + 1; %Add new route
                         A(:,numRoutes) = A(:,numRoutes-length(Store1)-length(Store2)-1+c); %Add new row to A
                         Time(:,numRoutes) = Time(:,numRoutes-length(Store1)-length(Store2)-1+c); %Add new row to Time
                         Cost(numRoutes) = Cost(:,numRoutes-length(Store1)-length(Store2)-1+c); %Add new row to Cost
                         A(j,numRoutes) = 1; %Add new job to row
                         Cost(numRoutes) = Cost(numRoutes)+(1-x)*TravelCost(Location(Store1(c)),Location(j),a)...
                             +x*(CostFromDepot(Location(Store1(c)),a)+10000+CostFromDepot(Location(j),a));
                         if (Time(Store1(c),numRoutes-1-length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location...
                                 (Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)+8+...
                                 TimeFromDepot(Location(j),a)))>=TimeWindow(j,1)
                         Time(j,numRoutes) = Time(Store1(c),numRoutes-length(Store1)-length(Store2)-1+c)...
                                +(1-x)*TravelTime(Location(Store1(c)),Location(j),a)+x*(TimeFromDepot(Location...
                                (Store1(c)),a)+8+TimeFromDepot(Location(j),a))+JobDuration(j,a); %Update time in time matrix
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                         else
                             Cost(numRoutes) = Cost(numRoutes) + (TimeWindow(j,1)-(Time(Store1(c),numRoutes-1-...
                                 length(Store1)+c-length(Store2))+(1-x)*TravelTime(Location(Store1(c)),Location(j),a)...
                                 +x*(TimeFromDepot(Location(Store1(c)),a)+8+TimeFromDepot(Location(j),a))))*SalaryCrew(a);
                             Time(j,numRoutes) = TimeWindow(j,1) + JobDuration(j,a);
                            if Location(Store1(c)) ~= 7 && Location(j) == 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                            if Location(Store1(c)) == 7 && Location(j) ~= 7
                                Time(j,numRoutes) = Time(j,numRoutes) + 24; %Add extra time for cleaning vessel if it crosses production zone
                            end
                         end
                         
                        end
                        Store2 = [Store2;j]; %Add new job to store.
                        elseif (Time(Store1(c),numRoutes-z-length(Store1)+c-length(Store2))+(1-x)*TravelTime...
                                (Location(Store1(c)),Location(j),a)+x*(TimeFromDepot(Location(Store1(c)),a)...
                                +8+TimeFromDepot(Location(j),a))+t)>=TimeWindow(j,2)... 
                            && A(j,numRoutes-z-length(Store1)+c-length(Store2)) == 0 && JobShipCompatibility(a,JobType(j)) == 1 && t>0
                        A(:,numRoutes) = [];
                        Time(:,numRoutes) = [];
                        Cost(:,numRoutes) = [];
                        numRoutes=numRoutes-1;
                        end
                    end
                end
                Store1 = Store2; %Move new jobs in store to first store matrix 
                Store2 = []; %Empty second store matrix.
                
            end
            
            n = n+1; %Update counter
        end
    
        
    elseif TimeFromDepot(Location(i),a)+t >= TimeWindow(i,2) && JobShipCompatibility(a,JobType(i)) == 1 ...
            && sum(A(:,numRoutes)) == 1
        A(:,numRoutes)=[];
        Time(:,numRoutes)=[];
        Cost(:,numRoutes) = [];
        numRoutes= numRoutes-1;
    end
    end
    
    A( :, ~any(A,1) ) = [];  %removing zero-columns
    Time( :, ~any(Time,1) ) = [];  %removing zero-columns
    Cost(Cost==0) = [];
    
    for x=1:size(A,2)
        for y = 1:size(A,1)
        if Time(y,x) == max(Time(:,x))
            Cost(x) = Cost(x) + CostFromDepot(Location(y),a);
            Time(y,x) = Time(y,x) + TimeFromDepot(Location(y),a)-504;
        break
        end
        end
        
    end
    
  
    for x=1:size(A,2)
        for y = 1:size(A,1)
            if A(y,x) == 1
                Cost(x) = Cost(x) + LeasingCostVessel(a)*JobDuration(y,a);               
            elseif A(y,x) == JobType(y)
                if Time(y,x)-JobDuration(y,a)-TimeWindow(y,1)>0
                Cost(x) = Cost(x) + (4.5-4.5/(1+GrowthRate)^(Time(y,x)-0.5*JobDuration(y,a)-TimeWindow(y,1)))*NumberSalmon(y)*63;           
                end
            elseif A(y,x) == 1 && (JobType(y) == 2 || JobType(y) == 9)
                Cost(x) = Cost(x) + JobDuration(y,a)*FuelCostAH(a);
            end
        end
    end


    if a == 1
        A1 = A;
        Time1 = Time;
        numRoutes1 = numRoutes;
        Cost1 = Cost;
    elseif a== 2
        A2 = A;
        Time2 = Time;
        numRoutes2 = numRoutes;
        Cost2 = Cost;
    elseif a == 3
        A3 = A;
        Time3 = Time;
        numRoutes3 = numRoutes;
        Cost3 = Cost;
    elseif a == 4
        A4 = A;
        Time4 = Time;
        numRoutes4 = numRoutes;
        Cost4 = Cost;
    end
end

numRoutesTot = numRoutes1 + numRoutes2 + numRoutes3+numRoutes4;

numJobs = length(JobType);
A = [A1,A2,A3,A4];
Cost = [Cost1, Cost2, Cost3,Cost4];
Time = [Time1, Time2, Time3, Time4];
fopen('Datafile.txt','wt');
fileID = fopen('Datafile.txt','w');
fprintf(fileID,'numRoutesTotal :  %2d \n',numRoutesTot);
fprintf(fileID,'numRoutes1 :  %2d \n',numRoutes1);
fprintf(fileID,'numRoutes2 :  %2d \n',numRoutes2);
fprintf(fileID,'numRoutes3 :  %2d \n',numRoutes3);
fprintf(fileID,'numRoutes4 :  %2d \n',numRoutes4);
fprintf(fileID,'numJobs :  %2d \n',numJobs);
fprintf(fileID,'numVesselType : %2d \n',length(LeasingCostVessel));

fprintf(fileID,'A : [ \n');
for i = 1:size(A,1)
    for j = 1:size(A,2)
        fprintf(fileID,'%2d',A(i,j));
    end
        fprintf(fileID,'\n');
end
fprintf(fileID,' ]\n');

fprintf(fileID,'Cost : [');
for i = 1:length(Cost);
    fprintf(fileID,'%12.2f',Cost(i));      
end
fprintf(fileID,' ]\n');

fprintf(fileID,'Penalty : [\n');
for i =1:length(JobType)
    fprintf(fileID,'%2d\n',Penalty(i));
end
fprintf(fileID,' ]\n');

fprintf(fileID,'CostNewVessels : [40202 86434 117274 213126] \n'); 

fclose(fileID);

moselexec RouteOpt.mos

OptimalRoutes = load('Result.dat');
clearvars min max
OptRot = zeros(length(JobType),length(OptimalRoutes));
AscTime = zeros(length(JobType),length(OptimalRoutes));
for i = 1:length(OptimalRoutes)
    AscTime(:,i) = sort(Time(:,OptimalRoutes(i)));
end

for i = 1:length(OptimalRoutes)
    t = 1;
    for j = 1:length(JobType)
        if AscTime(j,i) >0
            for m = 1:length(JobType)
                if AscTime(j,i) == Time(m,OptimalRoutes(i))
                   OptRot(t,i) = m;
                   t = t+1;
                end
            end
        end
    end
end
figure(1)
subplot(2,2,4)
set(gca,'FontSize',14)
hold on
plot(Hs(504:ceil(max(max(Time(:,OptimalRoutes))))))
title('Simulated significant waveheight week 4')
xlabel('Time [hours]')
ylabel('Significant waveheight [m]')
disp('Optimal routes:')
disp(transpose(OptRot))

TimeafterJob = zeros(5,length(OptRot(:,1)));
MaxTime = zeros(5,length(OptRot(:,1)));
RoutesTravelled = zeros(5,length(OptRot(:,1)));
for i = 1:length(OptimalRoutes)
    disp('Total duration of route:')
    disp(max(Time(:,OptimalRoutes(i)))-504)
    MaxTime(i) = max(Time(:,OptimalRoutes(i)))-504;
    disp('Time after each job completed:')
    disp(transpose(sort(Time(:,OptimalRoutes(i)))))
    TimeafterJob(i,:) = transpose(sort(Time(:,OptimalRoutes(i))));
    RoutesTravelled(i,:) = transpose(OptRot(:,i));
end

  
A = {'OptimalRoutes';'OptimalRoutes';'OptimalRoutes';'OptimalRoutes';'OptimalRoutes'};
B = {'Duration';'Duration';'Duration';'Duration';'Duration'};
C = {'Time after Job';'Time after Job';'Time after Job';'Time after Job';'Time after Job'};
D = {'Total Cost'};
E = {'Vessels used';'Vessels used';'Vessels used';'Vessels used';'Vessels used'};
F = {'Jobs not performed';'Jobs not performed';'Jobs not performed'};
xlswrite('Resultater hysesong optimering.xlsx',A,'Ark4','A1')
xlswrite('Resultater hysesong optimering.xlsx',B,'Ark4','A6')
xlswrite('Resultater hysesong optimering.xlsx',C,'Ark4','A11')
xlswrite('Resultater hysesong optimering.xlsx',D,'Ark4','A16')
xlswrite('Resultater hysesong optimering.xlsx',E,'Ark4','A17')
xlswrite('Resultater hysesong optimering.xlsx',F,'Ark4','A22')
xlswrite('Resultater hysesong optimering.xlsx',RoutesTravelled,'Ark4','B1')
xlswrite('Resultater hysesong optimering.xlsx',MaxTime,'Ark4','B6')
xlswrite('Resultater hysesong optimering.xlsx',TimeafterJob,'Ark4','B11')
CostRoutes = load('CostRoutes.dat');
xlswrite('Resultater hysesong optimering.xlsx',CostRoutes,'Ark4','M1')
TotalCost = load('Cost.dat');
Vessels = load('Vessels.dat');
NotPerformed = load('NotPerformed.dat');
xlswrite('Resultater hysesong optimering.xlsx',Vessels,'Ark4','B17')
Penalty1 = xlsread('Lokasjoner Salmar.xlsx','Ark1','Q60:Q70'); %Read in penalty for not performing a job.
if isempty(NotPerformed) == false
    xlswrite('Resultater hysesong optimering.xlsx',NotPerformed,'Ark4','B22')
    for i = 1:length(NotPerformed)
    TotalCost = TotalCost-Penalty(NotPerformed(i))+Penalty1(NotPerformed(i));
    end
end
xlswrite('Resultater hysesong optimering.xlsx',TotalCost,'Ark4','B16')




OptJobType = zeros(size(OptRot));
OptLocation = zeros(size(OptRot));
for i = 1:size(OptRot,1)
    for j = 1:size(OptRot,2)
        if OptRot(i,j) >0
        OptJobType(i,j) = JobType(OptRot(i,j));
        OptLocation(i,j) = Location(OptRot(i,j));
        end
    end
end
disp('Jobtypes:')
disp(transpose(OptJobType))
disp('Locations:')
disp(transpose(OptLocation))

% figure(5)
% set(gca,'FontSize',16)
% hold on
% route=zeros(1,size(OptLocation,2));
% for i = 1:size(OptLocation,2)
%     x = [];
%     y = [];
%     labels=[];
%     for j = 1:size(OptLocation,1)
%         if OptLocation(j,i)>0
%         x(j) = Lat(OptLocation(j,i));
%         y(j) = Lon(OptLocation(j,i));
%         end
%     end
%     a = find(OptLocation(:,i));
%     x = [Portx(OptLocation(1,i),:),x,fliplr(Portx(OptLocation(a(end),i),:))];
%     y = [Porty(OptLocation(1,i),:),y,fliplr(Porty(OptLocation(a(end),i),:))];
%     labels = cellstr(num2str([1:(length(x)-10)]'));
%     plot(y(6:length(y)-5),x(6:length(x)-5),'o')
%     if OptimalRoutes(i) <=numRoutes1
%         route(i)=plot(y,x,'--b','DisplayName','Route 15 m cat');
%         text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,'VerticalAlignment','bottom','HorizontalAlignment',...
%             'right','color','blue')
%     elseif OptimalRoutes(i) >numRoutes1 && OptimalRoutes(i) <=(numRoutes1+numRoutes2)
%         route(i) = plot(y,x,'--k','DisplayName','Route 25 m cat');
%         text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,'VerticalAlignment','bottom','HorizontalAlignment',...
%             'left','color','black')
%     elseif OptimalRoutes(i)>(numRoutes1+numRoutes2) && OptimalRoutes(i) <=(numRoutes1+numRoutes2+numRoutes3)
%         route(i) = plot(y,x,'--r','DisplayName','Route 25 m cat with delouser');
%         text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,'VerticalAlignment','top','HorizontalAlignment',...
%             'right','color','red')
%     else
%         route(i)= plot(y,x,'--m','DisplayName','Route 40 m mono');
%         text(y(6:(length(y)-5)),x(6:(length(x)-5)),labels,'VerticalAlignment','top','HorizontalAlignment',...
%             'left','color','magenta')
%     end
% end
% plot_google_map
% legend([route],'Location','northwest')
% title('Routes travelled week 4')
% xlabel('Longitude')
% ylabel('Latitude')
            
toc            