 %% %%%%%%%%%%%%%%%%%%%%%%%%%%%    Plots from simulation    %%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

 % This script makes plots from the simulation data.
 
 %% Remember to load the data retrieved from the simulation. Also remember to load the 
 % excel sheets and opt_exit. All three are saved in a .mat file. 
 % The opt_exit file is written manually and saved as a .mat file.

%%  %%%% Making a better visualizartion of the data collected  %%%%

% Including NAme of type of job to the plots. 
% Use C1 to C45 for those plots that have too many jobs per route to avoid
% overlapping of description.
[raw, Names ]=xlsread('Duration_for_Simulation', 'Names', 'A1:A45');


% Finding how many jobs each route has
jobs=zeros(20,1);

for v=1:20
    count=0;
    for w=1:10
        if 0< Typ(v,w)
            count = count+1;
            jobs(v,1)=count;
        end
    end
end



%% Gather  all information for each starting time of each job and route in
%  in a matrix for each week

StartW1=zeros(50,k);
StartW2=zeros(50,k);
StartW3=zeros(50,k);
StartW4=zeros(50,k);


for t=1:k
    if 0< VesseL(1)
        for r=2:2:(2*jobs(1))
            StartW1(r/2,t)=W1R1(r-1,t);
        end  
    end
    
    if 0< VesseL(2)
        for r=2:2:(2*jobs(2))
            StartW1(r/2+10,t)=W1R2(r-1,t);
        end  
    end
    
    if 0< VesseL(3)
        for r=2:2:(2*jobs(3))
            StartW1(r/2+20,t)=W1R3(r-1,t);
        end  
    end
    
    if 0< VesseL(4)
        for r=2:2:(2*jobs(4))
            StartW1(r/2+30,t)=W1R4(r-1,t);
        end  
    end
    
    if 0< VesseL(5)
        for r=2:2:(2*jobs(5))
            StartW1(r/2+40,t)=W1R5(r-1,t);
        end  
    end
     
    if 0< VesseL(6)
        for r=2:2:(2*jobs(6))
            StartW2(r/2,t)=W2R1(r-1,t);
        end  
    end
    
    if 0< VesseL(7)
        for r=2:2:(2*jobs(7))
            StartW2(r/2+10,t)=W2R2(r-1,t);
        end  
    end
    
    if 0< VesseL(8)
        for r=2:2:(2*jobs(8))
            StartW2(r/2+20,t)=W2R3(r-1,t);
        end  
 
    end
    
    if 0< VesseL(9)
        for r=2:2:(2*jobs(9))
            StartW2(r/2+30,t)=W2R4(r-1,t);
        end  
    end
    
    if 0< VesseL(10)
        for r=2:2:(2*jobs(10))
            StartW2(r/2+40,t)=W2R5(r-1,t);
        end  
    end 

    if 0< VesseL(11)
        for r=2:2:(2*jobs(11))
            StartW3(r/2,t)=W3R1(r-1,t);
        end  
    end
    
    if 0< VesseL(12)
        for r=2:2:(2*jobs(12))
            StartW3(r/2+10,t)=W3R2(r-1,t);
        end  
    end
    
    if 0< VesseL(13)
        for r=2:2:(2*jobs(13))
            StartW3(r/2+20,t)=W3R3(r-1,t);
        end  
    end
    
    if 0< VesseL(14)
        for r=2:2:(2*jobs(14))
            StartW3(r/2+30,t)=W3R4(r-1,t);
        end  
    end
    
    if 0< VesseL(15)
        for r=2:2:(2*jobs(15))
            StartW3(r/2+40,t)=W3R5(r-1,t);
        end  
    end     

    if 0< VesseL(16)
        for r=2:2:(2*jobs(16))
            StartW4(r/2,t)=W4R1(r-1,t);
        end  
    end
    
    if 0< VesseL(17)
        for r=2:2:(2*jobs(17))
            StartW4(r/2+10,t)=W4R2(r-1,t);
        end  
    end
    
    if 0< VesseL(18)
        for r=2:2:(2*jobs(18))
            StartW4(r/2+20,t)=W4R3(r-1,t);
        end  
    end
    
    if 0< VesseL(19)
        for r=2:2:(2*jobs(19))
            StartW4(r/2+30,t)=W4R4(r-1,t);
        end  
    end
    
    if 0< VesseL(20)
        for r=2:2:(2*jobs(20))
            StartW4(r/2+40,t)=W4R5(r-1,t);
        end  
    end         
end

% Find the correct time window for the given job and week 
Time_WindW1=zeros(20,10);
Time_WindW2=zeros(20,10);

for c= 1:5
    d=1;
    while 0 < Typ(c,d)
        Time_WindW1(c,d)= Twind(Typ(c,d),1)/24;
        Time_WindW2(c,d)= Twind2(Typ(c,d),1)/24;
        d=d+1;
    end
    d=1;
    while 0 < Typ(c+5,d)
        Time_WindW1(c+5,d)= Twind(Typ(c+5,d)+12,1)/24;
        Time_WindW2(c+5,d)= Twind2(Typ(c+5,d)+12,1)/24;
        d=d+1;
    end
    d=1;
    while 0 < Typ(c+10,d)
        Time_WindW1(c+10,d)= Twind(Typ(c+10,d)+23,1)/24;
        Time_WindW2(c+10,d)= Twind2(Typ(c+10,d)+23,1)/24;
        d=d+1;
    end
    d=1;
    while 0 < Typ(c+15,d)
        Time_WindW1(c+15,d)= Twind(Typ(c+15,d)+34,1)/24;
        Time_WindW2(c+15,d)= Twind2(Typ(c+15,d)+34,1)/24;
        d=d+1;
    end
    
end



yS1=zeros(50,k);
yE1=zeros(50,k);
yS2=zeros(50,k);
yE2=zeros(50,k);
yS3=zeros(50,k);
yE3=zeros(50,k);
yS4=zeros(50,k);
yE4=zeros(50,k);

% Getting the correct time window for the given job 

% Week 1
yS1(1:10,1)=transpose(Time_WindW1(1,:));
yS1(11:20,1)=transpose(Time_WindW1(2,:));
yS1(21:30,1)=transpose(Time_WindW1(3,:));
yS1(31:40,1)=transpose(Time_WindW1(4,:));
yS1(41:50,1)=transpose(Time_WindW1(5,:));
yE1(1:10,1)=transpose(Time_WindW2(1,:));
yE1(11:20,1)=transpose(Time_WindW2(2,:));
yE1(21:30,1)=transpose(Time_WindW2(3,:));
yE1(31:40,1)=transpose(Time_WindW2(4,:));
yE1(41:50,1)=transpose(Time_WindW2(5,:));
% Week 2
yS2(1:10,1)=transpose(Time_WindW1(6,:));
yS2(11:20,1)=transpose(Time_WindW1(7,:));
yS2(21:30,1)=transpose(Time_WindW1(8,:));
yS2(31:40,1)=transpose(Time_WindW1(9,:));
yS2(41:50,1)=transpose(Time_WindW1(10,:));
yE2(1:10,1)=transpose(Time_WindW2(6,:));
yE2(11:20,1)=transpose(Time_WindW2(7,:));
yE2(21:30,1)=transpose(Time_WindW2(8,:));
yE2(31:40,1)=transpose(Time_WindW2(9,:));
yE2(41:50,1)=transpose(Time_WindW2(10,:));
% Week 3
yS3(1:10,1)=transpose(Time_WindW1(11,:));
yS3(11:20,1)=transpose(Time_WindW1(12,:));
yS3(21:30,1)=transpose(Time_WindW1(13,:));
yS3(31:40,1)=transpose(Time_WindW1(14,:));
yS3(41:50,1)=transpose(Time_WindW1(15,:));
yE3(1:10,1)=transpose(Time_WindW2(11,:));
yE3(11:20,1)=transpose(Time_WindW2(12,:));
yE3(21:30,1)=transpose(Time_WindW2(13,:));
yE3(31:40,1)=transpose(Time_WindW2(14,:));
yE3(41:50,1)=transpose(Time_WindW2(15,:));
% Week 4
yS4(1:10,1)=transpose(Time_WindW1(16,:));
yS4(11:20,1)=transpose(Time_WindW1(17,:));
yS4(21:30,1)=transpose(Time_WindW1(18,:));
yS4(31:40,1)=transpose(Time_WindW1(19,:));
yS4(41:50,1)=transpose(Time_WindW1(20,:));
yE4(1:10,1)=transpose(Time_WindW2(16,:));
yE4(11:20,1)=transpose(Time_WindW2(17,:));
yE4(21:30,1)=transpose(Time_WindW2(18,:));
yE4(31:40,1)=transpose(Time_WindW2(19,:));
yE4(41:50,1)=transpose(Time_WindW2(20,:));


% Expand the time windows so that it can be included in a boxplot. 
for s=2:k 
    yS1(:,s)=yS1(:,s-1);
    yE1(:,s)=yE1(:,s-1);
    yS2(:,s)=yS2(:,s-1);
    yE2(:,s)=yE2(:,s-1);
    yS3(:,s)=yS3(:,s-1);
    yE3(:,s)=yE3(:,s-1);
    yS4(:,s)=yS4(:,s-1);
    yE4(:,s)=yE4(:,s-1);
end


%% Calculate the number of jobs performed within their respective time
%windows.

%Week1
x=0;
count1=0;
for j = 1:k
    for i = 1:size(yE1,1)
        if StartW1(i,j) >0
            count1 = count1+1;
            if StartW1(i,j) <= yE1(i,j)
                x = x+1;
            end
        end
    end
end
Week1_Coverage = x/count1;

%Week2
y=0;
count2 = 0;
for j = 1:k
    for i = 1:size(yE2,1)
        if StartW2(i,j) >0
            count2 = count2+1;
            if StartW2(i,j) <= yE2(i,j)
                y = y+1;
            end
        end
    end
end
Week2_Coverage = y/count2;

%Week3
z=0;
count3=0;
for j = 1:k
    for i = 1:size(yE3,1)
        if StartW3(i,j) >0
            count3 = count3+1;
            if StartW3(i,j) <= yE3(i,j)
                z = z+1;
            end
        end
    end
end
Week3_Coverage = z/count3;

%Week4
w = 0;
count4=0;
for j = 1:k
    for i = 1:size(yE4,1)
        if StartW4(i,j) >0
            count4 = count4+1;
            if StartW4(i,j) <= yE4(i,j)
                w = w+1;
            end
        end
    end
end
Week4_Coverage = w/count4;

Total_Coverage = (x+y+z+w)/(count1+count2+count3+count4);

%%  Finding the correct job description for the given route and job. %%

Name_r=cell(20,10);
 for x=1:5 
    for y=1:10
         if 0 < Typ(x,y)
            Name_r(x,y)=Names(Typ(x,y));
         end
         
         if 0 < Typ(5+x,y)
            Name_r(5+x,y)=Names(12+Typ(5+x,y));
         end
         
         if 0 < Typ(10+x,y)
            Name_r(10+x,y)=Names(23+Typ(10+x,y));
         end
         
          if 0 < Typ(15+x,y)
            Name_r(15+x,y)=Names(34+Typ(15+x,y));
         end
    end
     
 end

%% Plotting end time of each route %%



% Find the number jobs per route 
meanTime=zeros(20,3);
numb=zeros(4,1);

for g=1:5
        if 0< jobs(g)
            numb(1) = numb(1)+1;
            numb(1)=numb(1);
        end

        if 0< jobs(g+5)
            numb(2) = numb(2)+1;
            numb(2)=numb(2);
        end

        if 0< jobs(g+10)
            numb(3) = numb(3)+1;
            numb(3)=numb(3);
        end

        if 0< jobs(g+15)
            numb(4) = numb(4)+1;
            numb(4)=numb(4);
        end
end

for f=1:20
    meanTime(f,2)=mean(Exit_time(f,:));
    meanTime(f,3)=max(Exit_time(f,:));  % Not used in any plot.
end                                     % shows max duration for each route

% Get the end time from the optmization to compare with the simulated
% result. Also remember to add 
meanTime(:,1)=opt_exit;
meanTime(6:6+numb(2)-1,1)=meanTime(6:6+numb(2)-1,1);
meanTime(11:11+numb(3)-1,1)=meanTime(11:11+ numb(3)-1,1);
meanTime(16:16+numb(4)-1,1)=meanTime(16:16+numb(4)-1,1);
    

%%  %%%%%%%   Plots  %%%%%%%

%% Plot of Mean starting time of each job compared to time windows
if 0< VesseL(1)
    figure(1)
    bh3=boxplot(transpose(StartW1(1:+jobs(1),:)));
    hold on
    bh1=boxplot(transpose(yS1(1:jobs(1),:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE1(1:jobs(1),:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 1 Route 1');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(1,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end


if 0< VesseL(2)
    figure(2)
    bh3=boxplot(transpose(StartW1(11:11+jobs(2)-1,:)));
    hold on
    bh1=boxplot(transpose(yS1(11:11+jobs(2)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE1(11:11+jobs(2)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 1 Route 2');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(2,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end



if 0< VesseL(3)
    figure(3)
    bh3=boxplot(transpose(StartW1(21:21+jobs(3)-1,:)));
    hold on
    bh1=boxplot(transpose(yS1(21:21+jobs(3)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE1(21:21+jobs(3)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 1 Route 3');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(3,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(4)
    figure(4)
    bh3=boxplot(transpose(StartW1(31:31+jobs(4)-1,:)));
    hold on
    bh1=boxplot(transpose(yS1(31:31+jobs(4)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE1(31:31+jobs(4)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 1 Route 4');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(4,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(5)
    figure(5)
    bh3=boxplot(transpose(StartW1(41:41+jobs(5)-1,:)));
    hold on
    bh1=boxplot(transpose(yS1(41:41+jobs(5)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE1(41:41+jobs(5)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 1 Route 5');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(5,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(6)
    figure(6)
    bh3=boxplot(transpose(StartW2(1:+jobs(6),:)));
    hold on
    bh1=boxplot(transpose(yS2(1:jobs(6),:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE2(1:jobs(6),:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 2 Route 1');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(6,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end


if 0< VesseL(7)
    figure(7)
    bh3=boxplot(transpose(StartW2(11:11+jobs(7)-1,:)));
    hold on
    bh1=boxplot(transpose(yS2(11:11+jobs(7)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE2(11:11+jobs(7)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 2 Route 2');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(7,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end



if 0< VesseL(8)
    figure(8)
    bh3=boxplot(transpose(StartW2(21:21+jobs(8)-1,:)));
    hold on
    bh1=boxplot(transpose(yS2(21:21+jobs(8)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE2(21:21+jobs(8)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 2 Route 3');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(8,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(9)
    figure(9)
    bh3=boxplot(transpose(StartW2(31:31+jobs(9)-1,:)));
    hold on
    bh1=boxplot(transpose(yS2(31:31+jobs(9)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE2(31:31+jobs(9)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 2 Route 4');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(9,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(10)
    figure(10)
    bh3=boxplot(transpose(StartW2(41:41+jobs(10)-1,:)));
    hold on
    bh1=boxplot(transpose(yS2(41:41+jobs(10)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE2(41:41+jobs(10)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 2 Route 5');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(10,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(11)
    figure(11)
    bh3=boxplot(transpose(StartW3(1:+jobs(11),:)));
    hold on
    bh1=boxplot(transpose(yS3(1:jobs(11),:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE3(1:jobs(11),:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 3 Route 1');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(11,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end


if 0< VesseL(12)
    figure(12)
    bh3=boxplot(transpose(StartW3(11:11+jobs(12)-1,:)));
    hold on
    bh1=boxplot(transpose(yS3(11:11+jobs(12)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE3(11:11+jobs(12)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 3 Route 2');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest')
    set(gca,'XTickLabel',Name_r(12,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end



if 0< VesseL(13)
    figure(13)
    bh3=boxplot(transpose(StartW3(21:21+jobs(13)-1,:)));
    hold on
    bh1=boxplot(transpose(yS3(21:21+jobs(13)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE3(21:21+jobs(13)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 3 Route 3');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(13,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(14)
    figure(14)
    bh3=boxplot(transpose(StartW3(31:31+jobs(14)-1,:)));
    hold on
    bh1=boxplot(transpose(yS3(31:31+jobs(14)-1,:)),'Colors',[12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE3(31:31+jobs(14)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 3 Route 4');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(14,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(15)
    figure(15)
    bh3=boxplot(transpose(StartW3(41:41+jobs(15)-1,:)));
    hold on
    bh1=boxplot(transpose(yS3(41:41+jobs(15)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE3(41:41+jobs(15)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 3 Route 5');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(15,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(16)
    figure(16)
    bh3=boxplot(transpose(StartW4(1:jobs(16),:)));
    hold on
    bh1=boxplot(transpose(yS4(1:jobs(16),:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE4(1:jobs(16),:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 4 Route 1');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(16,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(17)
    figure(17)
    bh3=boxplot(transpose(StartW4(11:11+jobs(17)-1,:)));
    hold on
    bh1=boxplot(transpose(yS4(11:11+jobs(17)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE4(11:11+jobs(17)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 4 Route 2');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(17,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end


if 0< VesseL(18)
    figure(18)
    bh3=boxplot(transpose(StartW4(21:21+jobs(18)-1,:)));
    hold on
    bh1=boxplot(transpose(yS4(21:21+jobs(18)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE4(21:21+jobs(18)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 4 Route 3');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(18,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end



if 0< VesseL(19)
    figure(19)
    bh3=boxplot(transpose(StartW4(31:31+jobs(19)-1,:)));
    hold on
    bh1=boxplot(transpose(yS4(31:31+jobs(19)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE4(31:31+jobs(19)-1,:)),'Colors',  [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 4 Route 4');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(19,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

if 0< VesseL(20)
    figure(20)
    bh3=boxplot(transpose(StartW4(41:41+jobs(20)-1,:)));
    hold on
    bh1=boxplot(transpose(yS4(41:41+jobs(20)-1,:)),'Colors', [12 195 82] ./ 255);
    hold on
    bh2=boxplot(transpose(yE4(41:41+jobs(20)-1,:)),'Colors', [12 195 82] ./ 255);
    title('Mean starting time of each job: Week 4 Route 5');
    boxes = findobj(gca,'Tag','Box');
    set(bh3,'linewidth',1.5);
    set(bh1,'linewidth',4.0);
    set(bh2,'linewidth',4.0);
    legend(boxes([end 1 2]),'Simulated mean starting time','Start time window'...
        ,'End time window','Location', 'northwest');
    set(gca,'XTickLabel',Name_r(20,:))
    set(gca,'FontSize',30)
    xlabel('Job description');
    ylabel('Days');   
    ylim([-inf, inf])
    grid on;
end

%% Plot of end times for each route per week compared with the optimized
%  end time. 

figure(21)
bar(meanTime(1:numb(1),1:2))
title('Week 1: Simulated weather compared with optimized solution')
legend('Optimized end time', 'Mean simulated end time ','Location', 'northeast');
set(gca,'FontSize',30)
grid on;
ylabel('Days');
xlabel('Route nr')


figure(22)
bar(meanTime(6:6+numb(2)-1,1:2))
title('Week 2: Simulated weather compared with optimized solution')
legend('Optimized end time', 'Mean simulated end time ','Location', 'northeast');
set(gca,'FontSize',30)
grid on;
ylabel('Days');
xlabel('Route nr')
ylim([7, max(max(meanTime(6:6+numb(2)-1,1:2)))+1]);

figure(23)
bar(meanTime(11:11+numb(3)-1,1:2))
title('Week 3: Simulated weather compared with optimized solution')
legend('Optimized end time', 'Mean simulated end time ','Location', 'northeast');
set(gca,'FontSize',30)
grid on;
ylabel('Days');
xlabel('Route nr')
ylim([14,  max(max(meanTime(11:11+numb(3)-1,1:2)))+1]);

figure(24)
bar(meanTime(16:16+numb(3)-1,1:2))
title('Week 4: Simulated weather compared with optimized solution')
legend('Optimized end time', 'Mean simulated end time ','Location', 'northeast');
set(gca,'FontSize',30)
grid on;
ylabel('Days');
xlabel('Route nr')
ylim([21,  max(max(meanTime(16:16+numb(4)-1,1:2)))+1]);

%% Deleting all variables in workspace that are not needed

clearvars b c d s Lim count i k n t r V v t w 